function [xc]=wf_clipper(x,p,vad)
% INPUTS
% x: input signal to be clipped in amplitude
% p: percentage of samples to be clipped and that belong
% to the voice active segments
% vad: binary vector that indicates the voice-active parts (vad=1)
% Obs.: vad can be obtained via function vad_v3.m and related functions

%OUTPUTS:
%xc: signal with clipped samples

nsvad=length(find(vad)); % number of samples in the vad segments
xc_ref=x.*vad;  % set to zero samples outside the vad

thr=0.5*max(abs(xc_ref));  % initial clipping threshold
t_p=p;  % target percentage of clipped samples
a_p=0;  % actual percentage of clipped samples
ite_count=0;
while ((abs(t_p-a_p)) > p*0.05)&&(ite_count<40),
    aux=abs(xc_ref)>thr;
    xc=x;
    xc(aux)=thr.*sign(xc_ref(aux));   
    a_p=100*length(find(x-xc))/nsvad;
    e=abs(a_p-t_p);
    if a_p > t_p,
        thr=(1+0.1*e)*thr;
    else
        thr=(1-0.1*e)*thr;
    end
    ite_count=ite_count+1;
end


