function [x]=wf_clipper2(x,pclip,vad)

% x: input signal to be amplitude-clipped
% pclip: percentage (in %) of clipped samples in voice-active regions
% vad: binary vector with voice-active regions (vad=1).

Nvad=sum(vad); % number of samples in voice-active regions
Nclipvad=ceil(pclip*Nvad/100); % number of clipped samples in VAD

xs=sort(abs(x),'descend');
v1=xs(Nclipvad); % sets an initial threshold at the value of the 
% Nclipvad-th sample (in magnitude)
aux=find(xs<v1);
thr=xs(aux(1));
clear xs aux v1
aux=abs(x)>thr;
xo=x;
x(aux)=thr.*sign(x(aux));   

%plot(abs(x-xo)); 
%[length(find(abs(x-xo))) Nclipvad]
%pause; close

